# -*- coding: utf-8 -*-

#36fighter.rb
#全ての戦士の親となるクラスFighterと
#そのサブクラスHero, Enemy
#さらに、ハチロー・佐乃間を表すNonPlayerクラスを定義


class Fighter

	#Rubyで決まっている特殊な初期化メソッド
	def initialize(name, hp, bigger, smaller, just, win, lose)
		@name=name
		@hp=hp
		@bigger=bigger
		@smaller=smaller
		@just=just
		@win=win
		@lose=lose
	end

	#インスタンス変数の値そのものを読み取るメソッド
		def name
			@name
		end
		def hp
			@hp
		end
		def attack
			@attack
		end

	#HPを読みやすい形で表示
	def report_hp
		print @name
		print ": HP"
		puts @hp
	end

	#攻撃力を表示
		def report_attack
		print @name
		print " : 攻撃力"
		puts @attack
	end


	#表示にしか使わない変数の値を
	#表示（出力）する
	def bigger
		puts @bigger
		end
		def smaller
		puts @smaller
		end
		def just
		puts @just
		end
		def win
		puts @win
		end
		def lose
		puts @lose
	end


	#引数で指定した値だけ、HPを減らす
	def weaken damage
		@hp=@hp-damage
	end


	#HPが0より大きいか否かを判定する
	#オーイ生きてるかーい
	def alive?
		if @hp>0 then
			return true	#合致すればtrueを戻してメソッド終了
		end
		false	#合致しなければ一気にここまで来る
	end

	#do_attackメソッドは
	#名前だけ決めておく
	
	def do_attack
	end

end #Fighter定義の終わり


#Fighterのサブクラス
class Hero < Fighter

	#Heroは攻撃力をキー入力
	def do_attack
		print "攻撃力をいくつにしますか?>"
		@attack=gets.chomp.to_i
	end

end


#Fighterのサブクラス
class Enemy < Fighter

	#Enemyの攻撃力は
	#1から自分のHPまでのランダムな値
	def do_attack
		@attack=rand(@hp)+1
	end
	
end


#Fighterのサブクラス
#do_attackメソッドの中身を変更できる
class NonPlayer < Fighter

	#do_attackメソッドに指定する処理を
	#ブロックで引数に渡す
	def set_function(&function)
		@function=function	#Procオブジェクトに変換された
	end

	#これがNonPlayerの攻撃方法
	#Procオブジェクトの@functionの中身を実行
	def do_attack
		@attack=@function.call
	end

end
