# -*- coding: utf-8 -*-

#37battle.rb
#戦いの進行を記述する


#1回の勝負と判定、両者のHPの変更まで
class Battle

	#戦いをするHeroオブジェクトとEnemyオブジェクトを指定
	def initialize(hero, enemy)
		@hero=hero
		@enemy=enemy
	end


	def fight_single

		#両者のHPを表示
		puts "********************"
		@hero.report_hp
		@enemy.report_hp
		puts "********************"

		#両者の攻撃力を決める
		@hero.do_attack
		@enemy.do_attack

		puts #見やすくする
		sleep 3 #敵の攻撃力の表示をドキドキで待つ

		#両者の攻撃力を表示
		puts "!!!!!!!!!!!!!!!!!!!!"
		@hero.report_attack
		@enemy.report_attack
		puts "!!!!!!!!!!!!!!!!!!!!"

		puts
		sleep 2 #メッセージの表示前に改行と2秒の休み

		#敵は常に自身の攻撃力ぶんのHPを消費
		@enemy.weaken @enemy.attack

		#敵の攻撃力からひろしの攻撃力を引く
		result=@enemy.attack-@hero.attack

		#ひろしが「防御」した
		if result>0 then
			#引数にresultを指定
			@hero.weaken result
			#それぞれのメッセージ
			@enemy.bigger
			@hero.smaller

		#ひろし、自責の念にかられる
		elsif result<0 then
			#引数に@hero.attackを指定
			@hero.weaken @hero.attack
			@enemy.smaller
			@hero.bigger

		#ひろしのHP減少なし、最も望ましい結果
		else
			@enemy.just
			@hero.just

		end #ifの終わり

		puts

	end #fight_single定義の終わり
	
	
	#fight_singleを繰り返す
	def run

		#敵が生きているうちは繰り返す
		while @enemy.alive? do

		#まずは勝負だーッ
		fight_single

			#ひろしがヤラれた場合
			unless @hero.alive? then

			#運命の瞬間は2行改行
			puts
			puts
			sleep 3

			#Hero大敗北のご報告
			@enemy.win
			@hero.lose

			return #メソッドrun自体が終了

			end #unlessの終わり

		end #whileの終わり

		#繰り返し完了後ここに来る
		puts
		puts
		sleep 3
		
		#Hero大勝利のご報告
		@enemy.lose
		@hero.win

	end #run定義の終わり
	
	
end #Battle定義の終わり


#複数の敵と戦う
#get_heroメソッドはひろし1人を選ぶように固定
class MultiBattle	#どのクラスも継承していない

	#HeroオブジェクトとEnemyオブジェクトのそれぞれ配列を設定
	def initialize heroes, enemies
		@heroes=heroes
		@enemies=enemies
	end


	#味方はひろし1人に固定
	def get_hero
		@heroes[0]
	end


	#キー入力で敵を選ぶ
	def get_enemy

		#正しい入力まで繰り返す。通常は繰り返さない
		loop do

			#インデックスよりも1大きい値を入力
			print "誰と戦いますか？>"
			index=gets.chomp.to_i-1

			
			#インデックスの値が適切ならループをやめる
			#通常はパツイチでやめれる
			if 0<=index && index<@enemies.length then

				#メソッドが終了して@enemies要素を返す
				return @enemies[index]
			end
			

			#不適切な値の入力時のみここに来て繰り返し
			puts "入力値が不正です"

		
		end	#loopによる繰り返しのオワリ

	end #get_enemy定義のオワリ


	#全員のHPを表示
	def list_fighters
		puts "********************"
		
		#配列@heroes中の要素について繰り返す
		@heroes.each do |hero|
			print hero.name
			print ": HP"
			puts hero.hp
		end
		
		#味方と敵のHP表示の間を1行空ける
		puts
		
		#配列@enemies中の要素について繰り返す
		@enemies.each_index do |i|
			enemy=@enemies[i]
			#インデックスは0からなのでi+1で表示
			print i+1
			print "." #「1.」みたく番号に打つ「ドット」
			print enemy.name
			print ": HP"
			puts enemy.hp
		end
		
		puts "********************"
		puts	#見やすくする
	end


	#Battleクラスのfight_singleを利用した
	#独自のfight_singleメソッド
	def fight_single

		#全員の名前とHPを表示
		list_fighters

		#味方と敵を選ぶ
		hero=get_hero
		enemy=get_enemy

		#1回の勝負、双方のHPが減る
		battle=Battle.new hero, enemy	#Battleクラスのインスタンスを作成
		battle.fight_single	#Battleクラスのfight_singleが実行される

		#敵のHPがなくなったら
		unless enemy.alive? then

			sleep 1
			puts

			#敵を一匹排除したときのメッセージ
			enemy.lose
			hero.win

			#ヤラレた敵を配列から削除
			@enemies.delete enemy

		end

		#味方のHPがなくなったら
		unless hero.alive? then

			sleep 1
			puts
			
			#味方が一匹排除されたときのメッセージ
			enemy.win
			hero.lose
			
			#ヤラレタのがひろしなら
			if hero ==@heroes[0] then
			
			sleep 3
			puts
			puts
			
			puts "ひろし使えねぇ！味方チーム解散"
			
			exit	#プログラム終了
			
			else
				@heroes.delete hero	#他のヤツなら、チームからはずされる
			end
		end

		puts #いずれにしろ空行

end	#fight_single定義の終わり



	#fight_singleメソッドを敵の全滅まで繰り返す
	def run

	#@enemiesの要素が「あるうちは」
		while @enemies.length>0 do
			fight_single
		end

		#敵が全滅したらここに来られる
		sleep 3
		puts
		puts

		puts "敵を殲滅！この世に悪は栄えない"

	end
	
end


#MultiBattleクラスを継承
#味方も複数で、順番に攻撃する
class PartyBattle < MultiBattle

	#@turnを導入
	def initialize heroes, enemies
		super heroes, enemies
		@turn=0
	end

	#@heroesの要素を順番に取り出す
	def get_hero
		hero=@heroes[@turn%@heroes.length]
		puts "#{hero.name}の番です"
		hero
	end


	#@turnを1増やす
	def fight_single
		super
		@turn+=1
	end
	
end


